// -*- C++ -*- //

#ifndef MAP_WIN_H
#define MAP_WIN_H

class MapWin;

#include <all_include.h>
#include <nbtab.h>
#include <mapselector.h>
#include <libgnomecanvasmm.h>
#include <libgnomecanvasmm/polygon.h>

///This class is responsible for creating a window,
///on which the visualization attributes can be
///assigned to maps.
class MapWin : public Gtk::Window
{
protected:
  NoteBookTab & mytab;

  Gtk::Table * table;
  
  MapSelector ** e_combo_array, ** n_combo_array;

  Gtk::Label * label;

  Gtk::VBox vbox;

public:
  ///Constructor of MapWin creates the widgets shown in MapWin.
  MapWin(const std::string& title, std::vector<std::string>, std::vector<std::string>, NoteBookTab & mw);

  ~MapWin();

  virtual bool on_delete_event(GdkEventAny *);

  void nodeMapChanged(std::string, int);

  void edgeMapChanged(std::string, int);

  void newMapWinNeeded(bool);

  ///This function inserts name of the new edgemap in the list in the combo box
  void registerNewEdgeMap(std::string);

  ///This function inserts name of the new nodemap in the list in the combo box
  void registerNewNodeMap(std::string);

  virtual bool closeIfEscapeIsPressed(GdkEventKey*);

  void update(std::vector<std::string>, std::vector<std::string>);
};

#endif //MAP_WIN_H
